<template>
  <v-row justify="center">
    <v-col cols="12" sm="8" md="6">

      <v-card>
        <v-card-text>
          <v-form ref="form">
            <v-text-field
              v-model="inputElement.name"
              :counter="max"
              label="Agregar elemento"
              @keydown.enter.prevent='addElement'
            ></v-text-field>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer/>
          <v-btn v-show="!isEdit" color="primary" @click="addElement"> Add</v-btn>
          <v-btn v-show="isEdit" color="primary" @click="updateElement"> Edit</v-btn>
        </v-card-actions>
      </v-card>
    </v-col>

    <v-col cols="12" sm="8" md="6">

      <v-card>
        <v-card-title class="headline">
          Listado de artículos
        </v-card-title>
        <v-card-text>

          <v-list>
            <v-list-item-group
              color="primary"
            >
            <v-list-item
              v-for="{_id, name} in items"
              :key="_id"
            >
              <v-list-item-content>
                <v-list-item-title v-text="name"></v-list-item-title>
              </v-list-item-content>

              <v-list-item-action class="d-flex flex-row justify-space-between">
                <v-btn class="mr-1" flex color="default" small @click="editElement(_id, name)">
                  <v-icon x-small>mdi-pencil</v-icon>
                </v-btn>
                <v-btn flex color="danger" small @click="deleteElement(_id)">
                  <v-icon x-small>mdi-minus-circle</v-icon>
                </v-btn>
              </v-list-item-action>
            </v-list-item>
            </v-list-item-group>
          </v-list>
        </v-card-text>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>

export default {
  name: 'IndexPage',
  data: () => ({
    max: 0,
    inputElement: {
      _id : null,
      name: ''
    },
    items: [],
    isEdit: false,
  }),
  async mounted() {
    await this.getElements();
  },
  methods: {
    reset() {
      this.inputElement = {
        _id: null,
        name: ''
      };
      this.isEdit = false;
      this.getElements();
    },
    async addElement() {
      if (this.inputElement.name.length === 0) {
        return;
      }

      if (this.isEdit) {
       await this.updateElement();
      } else {
        // @TODO: Add to mongo
        const response = await this.$axios.post('/todo/store',  this.inputElement);

        console.log(response);
      }

      this.reset();
    },
    async getElements() {
      const {data} = await this.$axios.get('/todo');
      this.items = data.data;
    },
    editElement(id, name) {
      this.inputElement._id = id;
      this.inputElement.name = name;
      this.isEdit = true;
    },
    async deleteElement(id) {
      await this.$axios.delete(`/todo/${id}/delete`);

      this.reset();
    },
    async updateElement() {
      await this.$axios.put('/todo/update',  this.inputElement);

      this.reset();
    },

  }
}
</script>
